/*  JPGalleg: JPEG loading routines for Allegro
 *
 *  version 1.1, by Angelo Mottola, May/June 2000
 *
 *  Demo program; this allows to load any jpg file from disk, using a
 *  standard Allegro file selector.
 *
 *  See the README file for instruction on using this package!
 */

#include <allegro.h>
#include "jpgalleg.h"



/* show:
 *  Shows specified bitmap on the screen, waiting for user input.
 */
void show(BITMAP *bmp, char *filename)
{
   char buf[256];
   clear(screen);
   blit(bmp, screen, 0, 0, 0, 0, bmp->w, bmp->h);
   text_mode(-1);
   sprintf(buf, "%s (%dx%d, %ld bytes)", get_filename(filename), bmp->w, bmp->h, file_size(filename));
   textout(screen, font, buf, 1, 2, makecol(0, 0, 0));
   textout(screen, font, buf, 1, 0, makecol(0, 0, 0));
   textout(screen, font, buf, 2, 1, makecol(0, 0, 0));
   textout(screen, font, buf, 0, 1, makecol(0, 0, 0));
   textout(screen, font, buf, 1, 1, makecol(255, 255, 255));
   while (!mouse_b && !keypressed());
   destroy_bitmap(bmp);
}



/* main:
 *  What'll do this function?
 */
int main(int argc, char *argv[])
{
   BITMAP *bmp;
   PALETTE pal;
   char file[256];
   int i;

   allegro_init();
   install_keyboard();
   install_mouse();

   set_color_depth(16);
   if (set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0)) {
      allegro_message("set_gfx_mode(): %s\n",allegro_error);
      return 1;
   }
   register_bitmap_file_type("jpg", load_jpg, NULL);

   select_palette(desktop_palette);
   strcpy(file,".");

   if (argc > 1) {
      bmp = load_bitmap(argv[1], NULL);
      if (bmp)
         show(bmp, argv[1]);
   }
   
   while (file_select("JPGalleg demo program. Select file:", file, "jpg")) {
      bmp = load_bitmap(file, NULL);
      if (!bmp) alert("Error loading JPEG image:", file, NULL, "OK", NULL, 0, 0);
      else
         show(bmp, file);
   }

   unselect_palette();
   set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
   return 0;
}
END_OF_MAIN()